package dev.shadowsoffire.apotheosis.adventure.client;

import dev.shadowsoffire.apotheosis.adventure.socket.SocketedGems;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.inventory.tooltip.TooltipComponent;
import net.minecraft.network.chat.Component;
import net.minecraft.client.renderer.MultiBufferSource;
import org.joml.Matrix4f;
import com.mojang.blaze3d.vertex.PoseStack;
import java.util.Iterator;
import net.minecraft.client.gui.GuiGraphics;
import com.google.common.collect.UnmodifiableIterator;
import net.minecraft.network.chat.FormattedText;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance;
import net.minecraft.client.gui.Font;
import java.util.Objects;
import net.minecraft.client.Minecraft;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.gui.screens.inventory.tooltip.ClientTooltipComponent;

public class SocketTooltipRenderer implements ClientTooltipComponent
{
    public static final ResourceLocation SOCKET;
    private final SocketComponent comp;
    private final int spacing;
    
    public SocketTooltipRenderer(final SocketComponent comp) {
        Objects.requireNonNull(Minecraft.m_91087_().f_91062_);
        this.spacing = 9 + 2;
        this.comp = comp;
    }
    
    public int m_142103_() {
        return this.spacing * this.comp.gems.size();
    }
    
    public int m_142069_(final Font font) {
        int maxWidth = 0;
        for (final GemInstance inst : this.comp.gems.gems()) {
            maxWidth = Math.max(maxWidth, font.m_92852_((FormattedText)getSocketDesc(inst)) + 12);
        }
        return maxWidth;
    }
    
    public void m_183452_(final Font font, final int x, int y, final GuiGraphics gfx) {
        for (int i = 0; i < this.comp.gems.size(); ++i) {
            gfx.m_280398_(SocketTooltipRenderer.SOCKET, x, y + this.spacing * i, 0, 0.0f, 0.0f, 9, 9, 9, 9);
        }
        for (final GemInstance inst : this.comp.gems()) {
            if (inst.isValid()) {
                final PoseStack pose = gfx.m_280168_();
                pose.m_85836_();
                pose.m_85841_(0.5f, 0.5f, 1.0f);
                gfx.m_280203_(inst.gemStack(), 2 * x + 1, 2 * y + 1);
                pose.m_85849_();
            }
            y += this.spacing;
        }
    }
    
    public void m_142440_(final Font pFont, final int pX, final int pY, final Matrix4f pMatrix4f, final MultiBufferSource.BufferSource pBufferSource) {
        for (int i = 0; i < this.comp.gems.size(); ++i) {
            pFont.m_272077_(getSocketDesc(this.comp.gems.get(i)), (float)(pX + 12), (float)(pY + 1 + this.spacing * i), 11189196, true, pMatrix4f, (MultiBufferSource)pBufferSource, Font.DisplayMode.NORMAL, 0, 15728880);
        }
    }
    
    public static Component getSocketDesc(final GemInstance inst) {
        if (!inst.isValid()) {
            return (Component)Component.m_237115_("socket.apotheosis.empty");
        }
        return inst.getSocketBonusTooltip();
    }
    
    static {
        SOCKET = new ResourceLocation("apotheosis", "textures/gui/socket.png");
    }
    
    record SocketComponent(ItemStack socketed, SocketedGems gems) implements TooltipComponent {}
}
